=== debian/changelog ===
libtoxcore (0.2.22-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.3

 -- Yangfl <mmyangfl@gmail.com>  Wed, 25 Feb 2026 04:37:48 +0800
